/////////////////////////////////////////////////////////////////////////////
// ConnectSocket.cpp : implementation file
//

#include "stdafx.h"

#include "FireWall.h"
#include "FireWallDoc.h"
#include "Connection.h"
#include "ConnectSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CConnectSocket, CSocket)
	//{{AFX_MSG_MAP(CConnectSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CConnectSocket

CConnectSocket::CConnectSocket(CConnection *pConn)
{
	m_pConn = pConn;
	m_pFile = NULL;
	m_pInArc = NULL;
	m_pOutArc = NULL;
}

CConnectSocket::~CConnectSocket()
{
	if (m_pInArc != NULL)
		delete m_pInArc;
	if (m_pOutArc != NULL)
		delete m_pOutArc;
	if (m_pFile != NULL)
		delete m_pFile;
}

/////////////////////////////////////////////////////////////////////////////
// CConnectSocket member functions

void CConnectSocket::Init()
{
	if (m_pInArc != NULL)
		delete m_pInArc;
	if (m_pOutArc != NULL)
		delete m_pOutArc;
	if (m_pFile != NULL)
		delete m_pFile;

	m_pFile = new CSocketFile(this);
	m_pInArc = new CArchive(m_pFile,CArchive::load);
	m_pOutArc = new CArchive(m_pFile,CArchive::store);
}

void CConnectSocket::OnClose(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	CSocket::OnClose(nErrorCode);

	m_pConn->Close();
}

int CConnectSocket::SendMessage(void *msg, UINT msgLen)
{
	m_pOutArc->Write(msg, msgLen);
	m_pOutArc->Flush();

	return msgLen;
}

int CConnectSocket::ReceiveMessage(void *msg, UINT msgLen)
{
	UINT i = 0;

	do
	{
		m_pInArc->Read((BYTE*)msg + i++, 1);
	}
	while (i<msgLen && !m_pInArc->IsBufferEmpty());

	return i;
}
