/////////////////////////////////////////////////////////////////////////////
// FireWallDoc.cpp : implementation of the CFireWallDoc class
//

#include "stdafx.h"

#include "FireWall.h"
#include "Connection.h"
#include "FireWallSocket.h"
#include "FireWallView.h"
#include "FireWallDoc.h"

#define TCP_PORT 8080

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFireWallDoc

IMPLEMENT_DYNCREATE(CFireWallDoc, CDocument)

BEGIN_MESSAGE_MAP(CFireWallDoc, CDocument)
	//{{AFX_MSG_MAP(CFireWallDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFireWallDoc construction/destruction

CFireWallDoc::CFireWallDoc()
{
	// TODO: add one-time construction code here

	m_pSocket = NULL;
}

CFireWallDoc::~CFireWallDoc()
{
	delete m_pSocket;
}

BOOL CFireWallDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	m_pSocket = new CFireWallSocket(this);
	if (m_pSocket->Create(TCP_PORT))
		if (m_pSocket->Listen())
			return TRUE;
	return FALSE;
}

void CFireWallDoc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class
	CConnection* pConn;

	while(!m_lpConnections.IsEmpty())
	{
		pConn = (CConnection*)m_lpConnections.RemoveHead();
		delete pConn;
	}
		
	if (!m_viewList.IsEmpty())
		((CEditView*)m_viewList.GetHead())->SetWindowText("");

	CDocument::DeleteContents();
}

/////////////////////////////////////////////////////////////////////////////
// CFireWallDoc serialization

void CFireWallDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFireWallDoc diagnostics

#ifdef _DEBUG
void CFireWallDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CFireWallDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFireWallDoc commands

CConnection *CFireWallDoc::OpenConnection()
{
	CConnection* pConn = new CConnection(this);

	if (!pConn->AttachLocal(*m_pSocket))
	{
		delete pConn;
		return NULL;
	}
	m_lpConnections.AddTail(pConn);
	return pConn;
}

void CFireWallDoc::CloseConnection(CConnection *pConn)
{
	m_lpConnections.RemoveAt(m_lpConnections.Find(pConn));
	delete pConn;
}

void CFireWallDoc::Message(LPCTSTR lpszMessage)
{
	((CFireWallView*)m_viewList.GetHead())->Message(lpszMessage);
}
